"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cmd_ts_1 = require("cmd-ts");
const fs_1 = require("cmd-ts/batteries/fs");
const backupManager_1 = __importDefault(require("../libs/backupManager"));
exports.default = (0, cmd_ts_1.command)({
    name: "purge",
    description: "Purge all backups",
    args: {
        path: (0, cmd_ts_1.positional)({
            type: (0, cmd_ts_1.optional)(fs_1.ExistingPath),
            displayName: "path",
            description: "Path of the file or directory to remove from the backup",
        }),
    },
    handler({ path }) {
        const removed = backupManager_1.default.purge(path);
        console.log("Removed " + removed + " backups");
    },
});
