"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cmd_ts_1 = require("cmd-ts");
const fs_1 = require("cmd-ts/batteries/fs");
const backupManager_1 = __importDefault(require("../libs/backupManager"));
const utils_1 = require("../libs/utils");
exports.default = (0, cmd_ts_1.command)({
    name: "restore",
    aliases: ["restore"],
    description: "Remove pp-finder hooks from a javascript file or directory",
    args: {
        path: (0, cmd_ts_1.positional)({
            type: fs_1.ExistingPath,
            displayName: "Path",
            description: "Path of the file or directory to restore",
        }),
    },
    handler(args) {
        const files = (0, utils_1.getFileNames)(args.path);
        (0, utils_1.iterWithProgress)(files, (filename) => {
            const { isHooked } = (0, utils_1.readFile)(filename);
            if (isHooked) {
                backupManager_1.default.restore(filename, isHooked);
            }
        });
    },
});
