"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrowFunctionTransformer = void 0;
const typescript_1 = __importDefault(require("typescript"));
const utils_1 = require("./utils");
//  (({y}) => ())(x)
const arrowFunctionTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isArrowFunction(node) ||
        node.body === undefined ||
        node.parameters.length === 0) {
        return null;
    }
    // Transform
    const { newParameters, newStatements } = (0, utils_1.replaceParams)(node, utils);
    let oldStatements = [];
    const oldBody = utils.visit(node.body);
    if (typescript_1.default.isBlock(oldBody)) {
        oldStatements.push(...oldBody.statements);
    }
    else {
        oldStatements.push(typescript_1.default.factory.createReturnStatement(oldBody));
    }
    return typescript_1.default.factory.updateArrowFunction(node, node.modifiers, node.typeParameters, newParameters, node.type, node.equalsGreaterThanToken, typescript_1.default.factory.createBlock([...newStatements, ...oldStatements]));
};
exports.arrowFunctionTransformer = arrowFunctionTransformer;
exports.default = exports.arrowFunctionTransformer;
