"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.elementAccessTransformer = exports.doRequireBind = void 0;
const typescript_1 = __importDefault(require("typescript"));
const utils_1 = require("./utils");
function doRequireBind(node) {
    if (typescript_1.default.isCallExpression(node.parent)) {
        return !node.parent.arguments.some((x) => x === node);
    }
    return false;
}
exports.doRequireBind = doRequireBind;
// x[y]
const elementAccessTransformer = (node, utils) => {
    // Check
    if ((0, utils_1.isInAssignation)(node) ||
        !typescript_1.default.isElementAccessExpression(node) ||
        node.expression.kind === typescript_1.default.SyntaxKind.SuperKeyword) {
        return null;
    }
    if (typescript_1.default.isPostfixUnaryExpression(node.parent) ||
        typescript_1.default.isPrefixUnaryExpression(node.parent)) {
        return node;
    }
    const requireBind = doRequireBind(node);
    // TODO: Implement a better check than this, this is just a quick fix
    const isAsync = node.getText().includes("await");
    const k = typescript_1.default.factory.createIdentifier(utils.wrapperName + "k");
    const v = typescript_1.default.factory.createIdentifier(utils.wrapperName + "v");
    const nextgen = typescript_1.default.factory.createParenthesizedExpression(typescript_1.default.factory.createCallExpression(typescript_1.default.factory.createParenthesizedExpression(typescript_1.default.factory.createArrowFunction(isAsync
        ? [typescript_1.default.factory.createModifier(typescript_1.default.SyntaxKind.AsyncKeyword)]
        : [], undefined, [], undefined, typescript_1.default.factory.createToken(typescript_1.default.SyntaxKind.EqualsGreaterThanToken), typescript_1.default.factory.createBlock([
        typescript_1.default.factory.createVariableStatement(undefined, typescript_1.default.factory.createVariableDeclarationList([
            typescript_1.default.factory.createVariableDeclaration(k, undefined, undefined, node.expression),
        ], typescript_1.default.NodeFlags.Const)),
        typescript_1.default.factory.createVariableStatement(undefined, typescript_1.default.factory.createVariableDeclarationList([
            typescript_1.default.factory.createVariableDeclaration(v, undefined, undefined, node.argumentExpression),
        ], typescript_1.default.NodeFlags.Const)),
        typescript_1.default.factory.createExpressionStatement(utils.createWrapperCall("elem", node.argumentExpression, [k, v])),
        typescript_1.default.factory.createReturnStatement(requireBind
            ? typescript_1.default.factory.createCallExpression(typescript_1.default.factory.createPropertyAccessExpression(typescript_1.default.factory.createElementAccessExpression(k, v), typescript_1.default.factory.createIdentifier("bind")), undefined, [k])
            : typescript_1.default.factory.createElementAccessExpression(k, v)),
    ], true))), undefined, []));
    if (isAsync) {
        return typescript_1.default.factory.createAwaitExpression(nextgen);
    }
    return nextgen;
};
exports.elementAccessTransformer = elementAccessTransformer;
exports.default = exports.elementAccessTransformer;
