"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.forInStatementTransformer = void 0;
const typescript_1 = __importDefault(require("typescript"));
// for (let y in x)
const forInStatementTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isForInStatement(node)) {
        return null;
    }
    // Transform
    const newNode = utils.createWrapperCall("forIn", node.expression, [
        utils.visit(node.expression),
    ]);
    return typescript_1.default.factory.updateForInStatement(node, utils.visit(node.initializer), newNode, utils.visit(node.statement));
};
exports.forInStatementTransformer = forInStatementTransformer;
exports.default = exports.forInStatementTransformer;
