"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.functionDeclarationTransformer = void 0;
const typescript_1 = __importDefault(require("typescript"));
const utils_1 = require("./utils");
// function f({y}) {}
const functionDeclarationTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isFunctionDeclaration(node) ||
        node.body === undefined ||
        node.parameters.length === 0) {
        return null;
    }
    // Transform
    const { newParameters, newStatements } = (0, utils_1.replaceParams)(node, utils);
    return typescript_1.default.factory.updateFunctionDeclaration(node, node.modifiers, node.asteriskToken, node.name, node.typeParameters, newParameters, node.type, typescript_1.default.factory.createBlock([
        ...newStatements,
        ...utils.visit(node.body).statements,
    ]));
};
exports.functionDeclarationTransformer = functionDeclarationTransformer;
exports.default = exports.functionDeclarationTransformer;
