"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InExpressionTransformer = void 0;
const typescript_1 = __importDefault(require("typescript"));
/**
 * TODO: FIXME:
 * // We don't handle this
 * get name() {
 *   if (!this || !(#name in this)) { // transforms to !(ø.isIn(this, #name, [67, 29])) which is not valid javascript
 *     throw new ERR_INVALID_THIS('File');
 *   }
 *
 *   return this.#name;
 * }
 */
// if (y in x)
const InExpressionTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isBinaryExpression(node) ||
        node.operatorToken.kind !== typescript_1.default.SyntaxKind.InKeyword) {
        return null;
    }
    // Transform
    return utils.createWrapperCall("isIn", node.right, [
        utils.visit(node.right),
        utils.visit(node.left),
    ]);
};
exports.InExpressionTransformer = InExpressionTransformer;
exports.default = exports.InExpressionTransformer;
