"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.propertyAccessTransformer = void 0;
const typescript_1 = __importDefault(require("typescript"));
const utils_1 = require("./utils");
// x.y
const propertyAccessTransformer = (node, utils) => {
    // Check
    if ((0, utils_1.isInAssignation)(node) ||
        !typescript_1.default.isPropertyAccessExpression(node) ||
        node.expression.kind === typescript_1.default.SyntaxKind.SuperKeyword) {
        return null;
    }
    // Transform
    const newNode = utils.createWrapperCall("prop", node.name, [
        utils.visit(node.expression),
        typescript_1.default.factory.createStringLiteral(node.name.text),
    ]);
    return typescript_1.default.factory.updatePropertyAccessExpression(node, newNode, utils.visit(node.name));
};
exports.propertyAccessTransformer = propertyAccessTransformer;
exports.default = exports.propertyAccessTransformer;
