"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.variableDeclarationTransformer = void 0;
const typescript_1 = __importDefault(require("typescript"));
const utils_1 = require("./utils");
// const {y} = x;
const variableDeclarationTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isVariableDeclaration(node) ||
        !typescript_1.default.isObjectBindingPattern(node.name) ||
        node.initializer === undefined) {
        return null;
    }
    // Transform
    const paths = Array.from((0, utils_1.iterBindingPatternPath)(node.name));
    const newNode = utils.createWrapperCall("bind", node.initializer, [
        utils.visit(node.initializer),
        typescript_1.default.factory.createArrayLiteralExpression(paths),
    ]);
    return typescript_1.default.factory.updateVariableDeclaration(node, utils.visit(node.name), node.exclamationToken, node.type, newNode);
};
exports.variableDeclarationTransformer = variableDeclarationTransformer;
exports.default = exports.variableDeclarationTransformer;
